Form field events in TypeScript PDF Viewer

16 Feb 20265 minutes to read

The Syncfusion TypeScript PDF Viewer exposes form field events that let developers react to user interactions, respond to form changes, and implement custom business logic. Use these events for validation, UI updates, logging, and workflow automation.

Form field events are triggered when a field is added, selected, modified, moved, resized, or removed.

Supported PDF form field events

The following table lists the supported form field events and their descriptions:

Form field events Description
formFieldAdd Triggered when a new form field is added, either through the Form Designer UI or programmatically.
formFieldClick Fired when a form field is clicked in the viewer.
formFieldDoubleClick Fired when a form field is double clicked.
formFieldFocusOut Triggered when a form field loses focus after editing.
formFieldMouseLeave Fired when the mouse pointer leaves a form field.
formFieldMouseOver Fired when the mouse pointer moves over a form field.
formFieldMove Triggered when a form field is moved to a new position.
formFieldPropertiesChange Fired when any form field property changes, such as font, color, or constraint values.
formFieldRemove Triggered when a form field is deleted from the document.
formFieldResize Fired when a form field is resized.
formFieldSelect Fired when a form field is selected in the Form Designer.
formFieldUnselect Fired when a previously selected form field is unselected.
validateFormFields Fired when form field validation fails during print or download actions.

Common use cases

Form field events can be used to:

  • Validate form data before printing or downloading
  • Track user interaction with form fields
  • Update UI elements dynamically
  • Log form changes for auditing
  • Trigger workflow actions based on field changes
  • Enforce business rules during form editing

Handle PDF Form Field Events

You can wire up form field events on the PDF Viewer instance to execute custom logic when specific actions occur.

const pdfViewer = new PdfViewer({
  // Basic examples for common form-field events
  formFieldAdd: (args: any) => { console.log('formFieldAdd', args); },
  formFieldRemove: (args: any) => { console.log('formFieldRemove', args); },
  formFieldPropertiesChange: (args: any) => { console.log('formFieldPropertiesChange', args); },

  // Additional events from the table
  formFieldClick: (args: any) => { console.log('formFieldClick', args); },
  formFieldDoubleClick: (args: any) => { console.log('formFieldDoubleClick', args); },
  formFieldFocusOut: (args: any) => { console.log('formFieldFocusOut', args); },
  formFieldMouseOver: (args: any) => { console.log('formFieldMouseOver', args); },
  formFieldMouseLeave: (args: any) => { console.log('formFieldMouseLeave', args); },
  formFieldMove: (args: any) => { console.log('formFieldMove', args); },
  formFieldResize: (args: any) => { console.log('formFieldResize', args); },
  formFieldSelect: (args: any) => { console.log('formFieldSelect', args); },
  formFieldUnselect: (args: any) => { console.log('formFieldUnselect', args); },
});

//Validation Event
pdfviewer.enableFormFieldsValidation = true;
pdfviewer.validateFormFields = (args: any) => {
  if (args && args.formField && args.formField.length > 0) {
    // Example: prevent the pending action and notify the user
    args.cancel = true;
    alert('Please fill all required fields. Missing: ' + args.formField[0].name);
    // Optionally focus or scroll to the field
  }
};

Event Behavior Notes

  • Events triggered through the UI and programmatic APIs use the same event handlers.
  • Property related events are raised immediately when changes occur.
  • Validation events are triggered only during print or download operations.

View Sample on GitHub

See also

PDF Viewer Form Field Events in Angular

24 Jun 20267 minutes to read

The Angular PDF Viewer provides a set of form field events that report changes associated with creating, selecting, modifying, moving, resizing, or removing form fields. These events supply metadata related to the affected field and are raised during user interaction or programmatic updates.

Validation‑related events are emitted when the viewer performs operations that require confirmation of field completion, such as print or download actions.

Supported PDF Form Field Events

The following table lists all supported form field events and their descriptions:

Form Field events Description Arguments
formFieldAdd Triggered when a new form field is added, either through the Form Designer UI or programmatically. formFieldAddArgs
formFieldClick Fired when a form field is clicked in the viewer. formFieldClickArgs
formFieldDoubleClick Fired when a form field is double clicked. formFieldDoubleClickArgs
formFieldFocusOut Triggered when a form field loses focus after editing. formFieldFocusOutEventArgs
formFieldMouseLeave Fired when the mouse pointer leaves a form field. formFieldMouseLeaveArgs
formFieldMouseOver Fired when the mouse pointer moves over a form field. formFieldMouseOverArgs
formFieldMove Triggered when a form field is moved to a new position. formFieldMoveArgs
formFieldPropertiesChange Fired when any form field property changes, such as font, color, or constraint values. formFieldPropertiesChangeArgs
formFieldRemove Triggered when a form field is deleted from the document. formFieldRemoveArgs
formFieldResize Fired when a form field is resized. formFieldResizeArgs
formFieldSelect Fired when a form field is selected in the Form Designer. formFieldSelectArgs
formFieldUnselect Fired when a previously selected form field is unselected. formFieldUnselectArgs
validateFormFields Fired when form field validation fails during print or download actions. validateFormFieldsArgs

Example

Form field events can be wired on the PDF Viewer instance to execute custom logic when specific actions occur.

import { Component, ViewChild } from '@angular/core';
import {
  PdfViewerModule,
  PdfViewerComponent,
  ToolbarService,
  MagnificationService,
  NavigationService,
  AnnotationService,
  TextSelectionService,
  TextSearchService,
  FormFieldsService,
  FormDesignerService,
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [PdfViewerModule],
  template: `
    <div class="content-wrapper">
      <ejs-pdfviewer
        #pdfviewer
        id="pdfViewer"
        [resourceUrl]="resourceUrl"
        [documentPath]="document"
        [enableFormFieldsValidation]="true"
        (formFieldAdd)="onFormFieldAdd($event)"
        (formFieldRemove)="onFormFieldRemove($event)"
        (formFieldPropertiesChange)="onFormFieldPropertiesChange($event)"
        (formFieldClick)="onFormFieldClick($event)"
        (formFieldDoubleClick)="onFormFieldDoubleClick($event)"
        (formFieldFocusOut)="onFormFieldFocusOut($event)"
        (formFieldMouseOver)="onFormFieldMouseOver($event)"
        (formFieldMouseLeave)="onFormFieldMouseLeave($event)"
        (formFieldMove)="onFormFieldMove($event)"
        (formFieldResize)="onFormFieldResize($event)"
        (formFieldSelect)="onFormFieldSelect($event)"
        (formFieldUnselect)="onFormFieldUnselect($event)"
        (validateFormFields)="validateFormFields($event)"
        style="height: 640px; display: block;">
      </ejs-pdfviewer>
    </div>
  `,
  providers: [
    ToolbarService,
    MagnificationService,
    NavigationService,
    AnnotationService,
    TextSelectionService,
    TextSearchService,
    FormFieldsService,
    FormDesignerService,
  ],
})
export class AppComponent {
  public document = 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf';
  public resourceUrl = 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib';
  @ViewChild('pdfviewer') public pdfviewer?: PdfViewerComponent;

  onFormFieldAdd(args: any) { console.log('formFieldAdd', args); }
  onFormFieldRemove(args: any) { console.log('formFieldRemove', args); }
  onFormFieldPropertiesChange(args: any) { console.log('formFieldPropertiesChange', args); }
  onFormFieldClick(args: any) { console.log('formFieldClick', args); }
  onFormFieldDoubleClick(args: any) { console.log('formFieldDoubleClick', args); }
  onFormFieldFocusOut(args: any) { console.log('formFieldFocusOut', args); }
  onFormFieldMouseOver(args: any) { console.log('formFieldMouseOver', args); }
  onFormFieldMouseLeave(args: any) { console.log('formFieldMouseLeave', args); }
  onFormFieldMove(args: any) { console.log('formFieldMove', args); }
  onFormFieldResize(args: any) { console.log('formFieldResize', args); }
  onFormFieldSelect(args: any) { console.log('formFieldSelect', args); }
  onFormFieldUnselect(args: any) { console.log('formFieldUnselect', args); }

  validateFormFields(args: any) {
    if (args && args.formField && args.formField.length > 0) {
      args.cancel = true;
      alert('Please fill all required fields. Missing: ' + args.formField[0].name);
    }
  }
}

Event Behavior Notes

  • Events triggered through the UI and programmatic APIs use the same event handlers.
  • Property related events are raised immediately when changes occur.
  • Validation events are triggered only during print or download operations.

View Sample on GitHub

See also

PDF Viewer Form Field Events in Vue

28 Feb 20267 minutes to read

The Syncfusion Vue PDF Viewer provides a comprehensive set of form field events that allow developers to track user interactions, respond to form changes, and implement custom business logic. These events can be used for scenarios such as validation, UI updates, logging, and workflow automation.

Form field events are triggered during actions such as adding, selecting, modifying, moving, resizing, and removing form fields.

Supported PDF Form Field Events

The following table lists all supported form field events and their descriptions:

Form Field events Description
formFieldAdd Triggered when a new form field is added, either through the Form Designer UI or programmatically.
formFieldClick Fired when a form field is clicked in the viewer.
formFieldDoubleClick Fired when a form field is double clicked.
formFieldFocusOut Triggered when a form field loses focus after editing.
formFieldMouseLeave Fired when the mouse pointer leaves a form field.
formFieldMouseOver Fired when the mouse pointer moves over a form field.
formFieldMove Triggered when a form field is moved to a new position.
formFieldPropertiesChange Fired when any form field property changes, such as font, color, or constraint values.
formFieldRemove Triggered when a form field is deleted from the document.
formFieldResize Fired when a form field is resized.
formFieldSelect Fired when a form field is selected in the Form Designer.
formFieldUnselect Fired when a previously selected form field is unselected.
validateFormFields Fired when form field validation fails during print or download actions.

Common Use Cases

Form field events can be used to:

  • Validate form data before printing or downloading
  • Track user interaction with form fields
  • Update UI elements dynamically
  • Log form changes for auditing
  • Trigger workflow actions based on field changes
  • Enforce business rules during form editing

Handle PDF Form Field Events

Form field events can be wired on the PDF Viewer instance to execute custom logic when specific actions occur. The following Vue Composition API example demonstrates wiring up the events and handling validation.

<template>
  <div>
    <ejs-pdfviewer id="pdfViewer" ref="pdfviewer"
      :documentPath="documentPath"
      :resourceUrl="resourceUrl"
      @formFieldAdd="onFormFieldAdd"
      @formFieldRemove="onFormFieldRemove"
      @formFieldPropertiesChange="onFormFieldPropertiesChange"
      @formFieldClick="onFormFieldClick"
      @formFieldDoubleClick="onFormFieldDoubleClick"
      @formFieldFocusOut="onFormFieldFocusOut"
      @formFieldMouseOver="onFormFieldMouseOver"
      @formFieldMouseLeave="onFormFieldMouseLeave"
      @formFieldMove="onFormFieldMove"
      @formFieldResize="onFormFieldResize"
      @formFieldSelect="onFormFieldSelect"
      @formFieldUnselect="onFormFieldUnselect"
      @validateFormFields="onValidateFormFields"
      style="height:640px" />
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  Annotation,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';

export default {
  components: { 'ejs-pdfviewer': PdfViewerComponent },
  provide: { PdfViewer: [Toolbar, Magnification, Navigation, Annotation, TextSelection, TextSearch, FormFields, FormDesigner, PageOrganizer] },
  data() {
    return {
      documentPath: 'https://cdn.syncfusion.com/content/pdf/form-filling-document.pdf',
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib',
    };
  },
  methods: {
    onFormFieldAdd(args) { console.log('formFieldAdd', args); },
    onFormFieldRemove(args) { console.log('formFieldRemove', args); },
    onFormFieldPropertiesChange(args) { console.log('formFieldPropertiesChange', args); },
    onFormFieldClick(args) { console.log('formFieldClick', args); },
    onFormFieldDoubleClick(args) { console.log('formFieldDoubleClick', args); },
    onFormFieldFocusOut(args) { console.log('formFieldFocusOut', args); },
    onFormFieldMouseOver(args) { console.log('formFieldMouseOver', args); },
    onFormFieldMouseLeave(args) { console.log('formFieldMouseLeave', args); },
    onFormFieldMove(args) { console.log('formFieldMove', args); },
    onFormFieldResize(args) { console.log('formFieldResize', args); },
    onFormFieldSelect(args) { console.log('formFieldSelect', args); },
    onFormFieldUnselect(args) { console.log('formFieldUnselect', args); },
    onValidateFormFields(args) {
      if (args && args.formField && args.formField.length > 0) {
        args.cancel = true;
        alert('Please fill all required fields. Missing: ' + args.formField[0].name);
        // Optionally focus or scroll to the field via EJ2 instance
        //const pdfviewer = this.$refs.pdfviewer.ej2Instances;
      }
    },
  },
};
</script>

Event Behavior Notes

  • Events triggered through the UI and programmatic APIs use the same event handlers.
  • Property related events are raised immediately when changes occur.
  • Validation events are triggered only during print or download operations.

View Sample on GitHub

See also

PDF Viewer Form Field Events in React

24 Jun 20269 minutes to read

The React PDF Viewer provides a set of form field events that report changes associated with creating, selecting, modifying, moving, resizing, or removing form fields. These events supply metadata related to the affected field and are raised during user interaction or programmatic updates.

Validation‑related events are emitted when the viewer performs operations that require confirmation of field completion, such as print or download actions.

Supported PDF Form Field Events

The following table lists all supported form field events and their descriptions:

Form Field events Description Arguments
formFieldAdd Triggered when a new form field is added, either through the Form Designer UI or programmatically. formFieldAddArgs
formFieldClick Fired when a form field is clicked in the viewer. formFieldClickArgs
formFieldDoubleClick Fired when a form field is double clicked. formFieldDoubleClickArgs
formFieldFocusOut Triggered when a form field loses focus after editing. formFieldFocusOutEventArgs
formFieldMouseLeave Fired when the mouse pointer leaves a form field. formFieldMouseLeaveArgs
formFieldMouseOver Fired when the mouse pointer moves over a form field. formFieldMouseOverArgs
formFieldMove Triggered when a form field is moved to a new position. formFieldMoveArgs
formFieldPropertiesChange Fired when any form field property changes, such as font, color, or constraint values. formFieldPropertiesChangeArgs
formFieldRemove Triggered when a form field is deleted from the document. formFieldRemoveArgs
formFieldResize Fired when a form field is resized. formFieldResizeArgs
formFieldSelect Fired when a form field is selected in the Form Designer. formFieldSelectArgs
formFieldUnselect Fired when a previously selected form field is unselected. formFieldUnselectArgs
validateFormFields Fired when form field validation fails during print or download actions. validateFormFieldsArgs

Example

You can wire up form field events on the PDF Viewer instance to execute custom logic when specific actions occur.

import * as React from 'react';
import * as ReactDOM from 'react-dom/client';
import './index.css';

import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  LinkAnnotation,
  BookmarkView,
  ThumbnailView,
  TextSelection,
  TextSearch,
  Print,
  Annotation,
  FormDesigner,
  FormFields,
  Inject
} from '@syncfusion/ej2-react-pdfviewer';

// Optional: If you want stronger typings for the event args, you can import from the core package:
// import type { FormFieldAddEventArgs, FormFieldRemoveEventArgs, ... } from '@syncfusion/ej2-pdfviewer';

function App(): JSX.Element {
  const viewerRef = React.useRef<PdfViewerComponent | null>(null);

  // ---------------------------
  // Form-field event handlers
  // ---------------------------

  const onFormFieldAdd = (args: any) => {
    console.log('formFieldAdd', args);
  };

  const onFormFieldRemove = (args: any) => {
    console.log('formFieldRemove', args);
  };

  const onFormFieldPropertiesChange = (args: any) => {
    console.log('formFieldPropertiesChange', args);
  };

  const onFormFieldClick = (args: any) => {
    console.log('formFieldClick', args);
  };

  const onFormFieldDoubleClick = (args: any) => {
    console.log('formFieldDoubleClick', args);
  };

  const onFormFieldFocusOut = (args: any) => {
    console.log('formFieldFocusOut', args);
  };

  const onFormFieldMouseOver = (args: any) => {
    console.log('formFieldMouseOver', args);
  };

  const onFormFieldMouseLeave = (args: any) => {
    console.log('formFieldMouseLeave', args);
  };

  const onFormFieldMove = (args: any) => {
    console.log('formFieldMove', args);
  };

  const onFormFieldResize = (args: any) => {
    console.log('formFieldResize', args);
  };

  const onFormFieldSelect = (args: any) => {
    console.log('formFieldSelect', args);
  };

  const onFormFieldUnselect = (args: any) => {
    console.log('formFieldUnselect', args);
  };

  // ---------------------------
  // Validation handler
  // ---------------------------
  const handleValidateFormFields = (args: any) => {
    if (args && args.formField && args.formField.length > 0) {
      // Prevent the pending action (submit/print/etc.)
      args.cancel = true;
      alert('Please fill all required fields. Missing: ' + args.formField[0].name);
      // Optionally: focus/scroll to the field here
    }
  };

  return (
    <div className="control-section">
      <PdfViewerComponent
        ref={viewerRef}
        id="pdfViewer"
        documentPath="https://cdn.syncfusion.com/content/pdf/form-designer.pdf"
        resourceUrl="https://cdn.syncfusion.com/ej2/31.1.23/dist/ej2-pdfviewer-lib"
        style=
        // Enable validation pipeline
        enableFormFieldsValidation={true}
        validateFormFields={handleValidateFormFields}
        // Wire form-field events
        formFieldAdd={onFormFieldAdd}
        formFieldRemove={onFormFieldRemove}
        formFieldPropertiesChange={onFormFieldPropertiesChange}
        formFieldClick={onFormFieldClick}
        formFieldDoubleClick={onFormFieldDoubleClick}
        formFieldFocusOut={onFormFieldFocusOut}
        formFieldMouseOver={onFormFieldMouseOver}
        formFieldMouseLeave={onFormFieldMouseLeave}
        formFieldMove={onFormFieldMove}
        formFieldResize={onFormFieldResize}
        formFieldSelect={onFormFieldSelect}
        formFieldUnselect={onFormFieldUnselect}
      >
        <Inject
          services={[
            Toolbar,
            Magnification,
            Navigation,
            LinkAnnotation,
            BookmarkView,
            ThumbnailView,
            TextSelection,
            TextSearch,
            Print,
            Annotation,
            FormDesigner,
            FormFields
          ]}
        />
      </PdfViewerComponent>
    </div>
  );
}

const root = ReactDOM.createRoot(document.getElementById('sample') as HTMLElement);
root.render(<App />);

Event Behavior Notes

  • Events triggered through the UI and programmatic APIs use the same event handlers.
  • Property related events are raised immediately when changes occur.
  • Validation events are triggered only during print or download operations.

View Sample on GitHub

See also